/* *********************************************************************************************** */

// #shader_type fragment

#version 330

/* *********************************************************************************************** */

uniform usampler2D texture0;
uniform float scale;

/* *********************************************************************************************** */

in VertexAttributes
{
  vec2 uv;
} vertex;

/* *********************************************************************************************** */

out vec4 fragment_colour;

/* *********************************************************************************************** */

void main()
{
  uvec4 texel = texture(texture0, vertex.uv);
  vec4 normalised_texel = vec4(texel) / scale;
  fragment_colour = normalised_texel;
}

/* *********************************************************************************************** *
 *
 * End
 *
 * *********************************************************************************************** */
